let AWS = require('aws-sdk')

class UserDataService{
  constructor(table, key){
    this.tableName = table
    this.key = key

    const awsDefaultRegion = process.env.AWS_DEFAULT_REGION
    let dynamoDBParams = {
      region: awsDefaultRegion
    }
    AWS.config.update(dynamoDBParams)
  }

  getItem(){
    return new Promise((resolve,reject)=>{
      let docClient = new AWS.DynamoDB.DocumentClient()
      const params = {
        TableName:this.tableName,
        Key: {
          id: this.key
        }
      }
      docClient.get(params, (err, data) => {
        if(err){
          reject(err)
        }else{
          resolve(data.Item)
        }
      })
    })
  }

  putItem(user){
    return new Promise((resolve,reject) => {
      let docClient = new AWS.DynamoDB.DocumentClient()
      const params ={
        TableName:this.tableName,
        Key: {
          id: this.key
        },
        ExpressionAttributeValues: {
          ':city': user.city,
          ':office': user.office
        },
        UpdateExpression: 'SET city = :city, office = :office',
      }

      docClient.update(params, err => {
        if(err){
          reject(err)
        }else{
          console.log(JSON.stringify(params))
          resolve(params)
        }
      })
    })
  }
}

module.exports= UserDataService